/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2210 from the
 * contents of XS.xs. Do not edit this file, edit XS.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "XS.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"


typedef struct arcfour_t {
    unsigned char sbox[256];
    int x;
    int y;
} *Crypt__RC4__XS;


static void setup_key(struct arcfour_t *ctx, unsigned char *key, size_t key_len)
{
    int x;
    int y = 0;
    int tmp;
    unsigned char *sbox = ctx->sbox;

    ctx->x = 0;
    ctx->y = 0;
    for (x = 0; x < 256; x++)
        sbox[x] = x;
    for (x = 0; x < 256; x++) {
        y = (y + sbox[x] + key[x % key_len]) % 256;

        tmp = sbox[x];
        sbox[x] = sbox[y];
        sbox[y] = tmp;
    }
}


static void arcfour_encrypt(struct arcfour_t *ctx,
                            const unsigned char *src, unsigned char *dist,
                            size_t l)
{
    int x = ctx->x;
    int y = ctx->y;
    int tmp;
    unsigned char *sbox = ctx->sbox;

    for (; l > 0; l--) {
        x++;
        if (x > 255)
            x = 0;
        y += sbox[x];
        if (y > 255)
            y -= 256;

        tmp = sbox[x];
        sbox[x] = sbox[y];
        sbox[y] = tmp;
        *dist++ = (*src++ ^ sbox[(sbox[x] + sbox[y]) % 256]);
    }
    ctx->x = x;
    ctx->y = y;
}



#line 74 "XS.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 126 "XS.c"

XS(XS_Crypt__RC4__XS_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__RC4__XS_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "class, key");
    {
	SV *	class = ST(0);
	SV *	key = ST(1);
	Crypt__RC4__XS	RETVAL;
#line 71 "XS.xs"
    {
        STRLEN l;
        struct arcfour_t *self;
        unsigned char *k;

        class = class; /* dummy code */
        Newz(0, self, 1, struct arcfour_t);
        k = (unsigned char *)SvPV(key, l);
        setup_key(self, k, l);
        RETVAL = self;
    }
#line 154 "XS.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::RC4::XS", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__RC4__XS_RC4); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__RC4__XS_RC4)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "obj_or_key, msg");
    {
	SV *	obj_or_key = ST(0);
	SV *	msg = ST(1);
	SV *	RETVAL;
#line 91 "XS.xs"
    {
        STRLEN l;
        struct arcfour_t ctx;
        struct arcfour_t *obj;
        unsigned char *key, *dist;
        const unsigned char *m; 

        if (sv_isobject(obj_or_key) && sv_derived_from(obj_or_key, "Crypt::RC4::XS")) {
            obj = INT2PTR(Crypt__RC4__XS, SvIV((SV*)SvRV(obj_or_key)));

            m = (unsigned char *)SvPV(msg, l);
            RETVAL = newSVsv(msg);
            dist = (unsigned char *)SvPV(RETVAL, l);
            arcfour_encrypt(obj, m, dist, l);
        }
        else {
            key = (unsigned char *)SvPV(obj_or_key, l);
            setup_key(&ctx, key, l);

            m = (const unsigned char *)SvPV(msg, l);
            RETVAL = newSVsv(msg);
            dist = (unsigned char *)SvPV(RETVAL, l);
            arcfour_encrypt(&ctx, m, dist, l);
        }
    }
#line 202 "XS.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Crypt__RC4__XS); /* prototype to pass -Wmissing-prototypes */
XS(boot_Crypt__RC4__XS)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK ;

        newXS("Crypt::RC4::XS::new", XS_Crypt__RC4__XS_new, file);
        newXS("Crypt::RC4::XS::RC4", XS_Crypt__RC4__XS_RC4, file);
#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

